;
; boot.s
; Generic startup code
;

	GET	PERI.INC

	AREA	BOOT_BSS,DATA,READWRITE
keybuff	%	2
keys	%	2
volume	%	2

    CODE32                          ; Subsequent instructions are ARM 
    AREA	BOOT, CODE, READONLY	; name this block of code

	IMPORT	IRQ_Callback_EXT
	IMPORT	FIQ_Callback_SPI
	IMPORT	IRQ_Callback_TC0
	IMPORT	IRQ_Callback_TC1
	IMPORT	IRQ_Callback_RTC
	IMPORT	IRQ_Callback_VOL
	IMPORT	IRQ_Callback_BAT
	IMPORT	IRQ_Callback_IF
	IMPORT	FIQ_Callback_TC2
	IMPORT	mymain
	EXPORT	keybuff
	EXPORT	keys
	EXPORT	volume

;----------------------------------------------------------------------------
	GET	Mhead.S			; Get memory card header at this point in the code
;----------------------------------------------------------------------------
    ENTRY                       	; Entry point

startup
	MOV	r0, #6						; Set system clock to 4MHz (6)
	SWI	4

	MOV	r0, #INTStatus				; Load base address of interrupt registers
	LDR	r1, =0x3fff
	STR	r1, [r0, #INTEnableReset_ofs]	; Disable IRQs and FIQs

	MOV	r0,#1
	ADR	r1,IRQ_Callback
	SWI	1

	MOV	r0, #0x200					; SRAM address
	MOV	r1, #0
clearSRAM
	STR	r1, [r0], #4				; Fill user SRAM with 0x00
	CMP	r0, #0x800
	BNE	clearSRAM
	MOV	sp, #0x00000800				; Set sp to top of user SRAM

	SWI		19						; Get user interface status
	LDR		r1,[r0]
	MOV		r1,r1,LSR #18
	AND		r1,r1,#3				; Get speaker volume setting
	CMP		r1,#2
	MOVEQ	r1,#0x10				; Correct format for menusnd
	LDR		r0,=volume				; 	Dunno why menusnd is called when off,
	STRH	r1,[r0]					; 	May be for future use.

	BL		mymain					; Branch to main

	SWI		22
	ORR		r2,r0,#0x30				; Application 0, argument 3
	MOV 	r0,#1
	MOV 	r1,#0
	SWI 	8						; Select application to return to
	MOV		r0,#0
	SWI 	9						; Terminate

;----------------------------------------------------------------------------
IRQ_Callback
    STMDB   sp!, {r2,r3, lr}
    MOV 	r2, #INTStatus
    LDR 	r0, [r2]
    LDR 	r1, [r2, #INTEnableSet_ofs]
    AND		r0, r0, r1

	AND		r1,r0,#0x1f				;keys only
	STR		r1,[r2,#INTEnableReset_ofs]
	LDR		r3,=keybuff
	LDRH	r2,[r3]
	ORR		r1,r2,r1
	STRH	r1,[r3]

	MOVS	r0,r0,LSR #7
	BEQ		IRQ_done
    ADR 	r1, IRQ_Branch
01
    MOVS    r0, r0, LSR #1
    MOVCS   lr, pc
  	LDRCS   pc, [r1]
    ADD 	r1, r1, #4
	CMP 	r0,#0
    BNE 	%B01
IRQ_done
    LDMIA   sp!, {r2,r3, pc}

IRQ_Branch
        DCD     IRQ_Callback_TC0
        DCD     IRQ_Callback_TC1
        DCD     IRQ_Callback_RTC
        DCD     IRQ_Callback_VOL
        DCD     IRQ_Callback_BAT
        DCD     IRQ_Callback_IF
        DCD     Null_Callback        	; TC2 FIQ interrupt
                                        ; all others are IRQs
;----------------------------------------------------------------------------
Null_Callback
	MOV	pc,lr
;----------------------------------------------------------------------------
	END