//
//	KEYS.C
//
//
//	Ver1.0
//

#include "devi_reg.h"
#define KEYEnter 	0x0001
#define KEYRight 	0x0002
#define KEYLeft		0x0004
#define	KEYDown		0x0008
#define KEYUp		0x0010

extern unsigned short keys;
unsigned long entertime;

void resettimer(){
	// Set counter rate depending on CPU freq
	// Should interrupt about every 1/32 seconds
	*TIMER0Control=0;
	*TIMER0Load=32<<((*PMFrequency)&0xf);
	*TIMER0Control=5;
}

void initkeys(){
	// Disable button and counter 0 interrupts
	*INTEnableReset=0x9f;
	*INTSourceClear=0x1f;

	// Reset key buffers
	keys=entertime=0;

	resettimer();
	// Re-enable the interrupts
	*INTEnableSet=0x9f;
}

void startkeys(){
	// Set counter rate depending on CPU freq
	// Should interrupt about every 1/32 seconds
	resettimer();

	*INTSourceClear=0x9f;
	*INTEnableSet=0x9f;
}

void stopkeys(){
	*INTEnableReset=0x9f;
	*INTSourceClear=0x9f;
}