/* ---------------------------------------------------------------------------
 * - (C) Sony Computer Entertainment. All Rights Reserved.
 * -
 * - Project:	PocketStation TRC Checker V1.0
 * -
 * - Name:		main.h
 * -
 * - Author:	Mike Kavallierou
 * -
 * - Date:		27/07/98
 * ---------------------------------------------------------------------------
 */
#ifndef __MAIN_H
#define __MAIN_H

/* ---------------------------------------------------------------------------
 * - CONSTANTS
 * ---------------------------------------------------------------------------
 */

#define INPUT_DELAY			5

// Screen position and dimensions. 
#define	FRAME_X			640
#define	FRAME_Y			256
#define SCREEN_X		0
#define SCREEN_Y		18	

#define MAX_VOL			127

/* ---------------------------------------------------------------------------
 * - DATA TYPE AND STRUCTURE DECLARATIONS
 * ---------------------------------------------------------------------------
 */
#define OTSIZE	2			// ordering table size
#define MAXOBJ	2			// 2 memory cards ..

 
typedef struct
{
	DRAWENV			draw;
	DISPENV			disp;
	unsigned long	ot[OTSIZE];			// ordering table
	POLY_FT4		polys[MAXOBJ];		// memory card polygons
} DB;

/* ---------------------------------------------------------------------------
 * - GLOBAL DECLARATIONS
 * ---------------------------------------------------------------------------
 */
 
//extern DB		db[2];		
//extern short	cdb;				// current display buffer
//unsigned long	*ot;				// current OT

//extern long		fIdA;				// Aplic font id.

/* ---------------------------------------------------------------------------
 * - LIBSN.LIB GLOBAL DECLARATIONS
 * ---------------------------------------------------------------------------
 */

extern unsigned long __heapbase;
extern unsigned long __heapsize;
extern unsigned long __bss;
extern unsigned long __bsslen;
extern unsigned long __data;
extern unsigned long __datalen;
extern unsigned long __text;
extern unsigned long __textlen;
extern unsigned long _ramsize;
extern unsigned long _stacksize;



// Function prototypes
void			InitSys(void); 
void			CloseSys(void);
void			VSyncCB(void);
void			ClearVRAM(void);
int				InitCDBrowser(void);
void			CreatePath(char *filename);
void			InitEnvs(DB *db);
void			SndInit(void);
void			MoveHighlight(int numEntries,int *highlight, int *offset,int number);
void			ParseFileType(int currentFile);
void			displayFileDetails(int file);
void			InitPoly(void);
void			drawViewerList(int viewerHighlight);
void			cdMenu(void);
void			FastForwardTrack(void);

#endif // __MAIN_H 
