/*
*	(C) Sony Computer Entertainment. All Rights Reserved.
*
*	PROJECT		PocketStation TRC Checker V1.0
*
*	CHANGED		PROGRAMMER		REASON
*	-------		----------		------
*	18/02/99	Mike Kav		Created
*
*/
#include <sys/types.h>
#include <kernel.h>
#include <libsn.h>
#include <libgte.h>
#include <libgpu.h>
#include <libetc.h>
#include <libcd.h>
#include <libspu.h>
#include <libsnd.h>
#include <stdio.h>
#include <strings.h>

#define BLOCK_SIZE 8192
#define BLOCKS(x)	(((x)+BLOCK_SIZE-1)/BLOCK_SIZE)

#define MAXBLOCK 15

#define UNSET	0
#define SET		1

// serial number is a 32 bit value, split into	high 8-bits - letter ID
//												low 24 bits - number value
// note this should match ID on case

#define GetSerialLetter(x)			(unsigned char)((x)->rawSerialNo>>24)
#define GetSerialNumber(x)			(((x)->rawSerialNo<<8)>>8)

typedef struct
{
	int state;					// Currently 1 for read and initialized 0 for not
	long numFiles;				// Number of files memory card contains
	unsigned long rawSerialNo;

} MEMCARDDETAILS;


// Normal memory card header (Max 15 blocks)
typedef struct
{
	unsigned char	magic[2];
	unsigned char	type;						// icon number: 0x11 1, 0x12 2, 0x13 3
	unsigned char	slots;						// number of slots
	unsigned char	title[64];
	unsigned char	pad[28];
	unsigned char	CLUT[32];					// end of 128 byte header
	unsigned char	Icons[3][128];
	unsigned char	block1[7680];
	unsigned char	block2_15[(8192*14)];

} CARDDATA;

// PocketStation memory card header (Max 15 blocks)
typedef struct
{
	unsigned char	magic[2];
	unsigned char	type;						// icon number: 0x11 1, 0x12 2, 0x13 3
	unsigned char	slots;						// number of slots
	unsigned char	title[64];
	unsigned char	pad[12];					// must be '\0'
	unsigned short	animIcons;					// number of animation icons
	unsigned char	fileType[4];				// PocketStation file type, MCX0,CRD0
	unsigned char	animPages;					// Animation pages
	unsigned char	numDrivers;					// Number of user device drivers
	unsigned char	reserved[4];				// reserved 0x00 '\0'
	unsigned long	startAddr;
	unsigned char	CLUT[32];					// end of 128 byte header
	unsigned char	Icons[3][128];
	unsigned char	block1[7680];
	unsigned char	block2_15[(8192*14)];

} CARDDATAEX;

void	MemManager(void);
void	InitCardSystem(void);
void	CloseCardSystem(void);

void	CheckCardState(void);
void	InitMemCard(void);
void	InitMemCardValues(void);
void	GetMemCardFile(void);
void	DrawFileList(void);
void	DisplayMemCardTitle(void);
void	TestTRC(void);
void	TRC111(void);
void	TRC112(void);
void	TRC113(void);
void	TRC114(void);

