//--------------------------------------------------------------------------
// File: main.c
// Author: George Bain
// Date: April 21, 1999
// Description: PocketStation demo
// Copyright (C) 1999 Sony Computer Entertainment Europe.,
//           All Rights Reserved.
// Notes: Compiled with ARM Project Manager for Windows v2.50  
//--------------------------------------------------------------------------

//--------------------------------------------------------------------------
// I N C L U D E S
//--------------------------------------------------------------------------

#include <devi_reg.h>
#include <keys.h>
#include <menu.h>	
#include "main.h"
#include "genlib.h"

//--------------------------------------------------------------------------
// G L O B A L S
//--------------------------------------------------------------------------

volatile u_char done;
u_long screen[SCRN_SIZE];
RECT rect;

//--------------------------------------------------------------------------
// Function: main
// Description: PocketStation demo
// Parameters: 
// Returns: none
// Notes: N/A
//--------------------------------------------------------------------------
	
int mymain( void )
 {


	register delay = DELAY;

	done = 0;
 
 	initkeys();

    gClearBackPlane();
	gClearScreen();

    setRECT(&rect,10,20,5,5);

	while( keys & KEYEnter );

	while( !done )
		{	
 	  
 	  		// get user input	
			if( keys & KEYRight )
			  {			   				
			    rect.x++;
	 		  }
			
			if( keys & KEYLeft )
			  {
			    rect.x--;			   
   			  }
			
			if( keys & KEYUp )
			  {
			    rect.y--;
   			  }
			
			if( keys & KEYDown )
			  {
			    rect.y++;
			  }	 
			 
			// check collision  	
			
			// move all 

 			// draw all
	 		gFillRect(rect.x,rect.y,rect.w,rect.h);

			// update back plane
		   	gUpdateScreen();

			// clear screen buffer
			gClearScreen();		 
			
			// delay
			while( delay-- );
	 				
	 		delay = DELAY;		

			if( entertime >=96 ) 
		    	done = exitmenu();

		}// end while

	return(0);

 }// end main
  

//-------------------------------E O F--------------------------------------