//
// pdakernel.h
//

//
// SWI declarations for PocketStation kernel services
//

//
// Mark Baker, 10/12/98
//
#ifndef _PDA_KERNEL_H
#define _PDA_KERNEL_H

__swi (0x0) void softwareReset (void);

__swi (0x1) unsigned long setUserCallback (unsigned long interruptType, unsigned long * callbackFunctionAddress);

__swi (0x2) unsigned long invokeUserCallback (void);

__swi (0x3) unsigned long writeFlashRelative (unsigned long destinationAddr, unsigned long * sourceAddr);

__swi (0x4) int setSystemClockFrequency (int frequency);

__swi (0x5) void switchKernelMode (void);

__swi (0x6) unsigned long * getPDAStatus (void);

__swi (0x8) unsigned long appBlockNumberControl (unsigned long function, unsigned long blockNumber, unsigned long appArgument);
// function = 0, get block number (blockNumber & appArgument are ignored)
// function = 1, set block number

__swi (0x9) void terminateApplication (unsigned long resume, unsigned long parameter);
// resume = 0, application is 'cold-started' with supplied parameter
// resume = 1, application is 'resumed'

__swi (0x10) unsigned long readSerialNumber (void);

__swi (0x11) void terminateFileTransfer (void);

__swi (0x12) unsigned long writeRTC (unsigned long yearMonthDay, unsigned long dowHourMinSec);

__swi (0x13) unsigned long readCalendar (void);

__swi (0x14) unsigned long readClock (void);

__swi (0x15) void writeSerialNumber (unsigned long serialNumber);

__swi (0x16) unsigned long writeFlashAbsolute (unsigned long destinationAddr, unsigned long * sourceAddr);

__swi (0x17) void controlPSXComms (unsigned long state);
// state = 0, communication stopped
// state = 1, communication started

__swi (0x18) unsigned long getAppStatus (unsigned long blockNumber);

__swi (0x19) unsigned long * getUIStatus (void);

__swi (0x20) unsigned long getSystemCallTable (void);

__swi (0x22) unsigned long getAppBlockNumber (void);

__swi (0x24) unsigned long getAppFlag (unsigned long blockNumber);

// system clock fequencies
#define SYSCLOCK_FREQ_62KHZ 	1
#define SYSCLOCK_FREQ_125KHZ 	2
#define SYSCLOCK_FREQ_250KHZ 	3
#define SYSCLOCK_FREQ_500KHZ 	4
#define SYSCLOCK_FREQ_1MHZ 		5
#define SYSCLOCK_FREQ_2MHZ 		6
#define SYSCLOCK_FREQ_4MHZ 		7
#endif