//
// strutil.c
//


//
// string utilities
//

#include "strutil.h"
#include "flash2ram.h"

//
// FormatNumber
//
// format a number to a string - copes with + or - and any size.
//
void FormatNumber (char * strOutput, signed long slNumber)
	{
	char strTemp[30];
	int iNumDigits = 0;
	signed long slSingleDigit;

	if (slNumber < 0)
		{
		*strOutput++ = '-';
		slNumber = -slNumber;
		}

	// put number in reverse order
	while (slNumber > 9)
		{
		slSingleDigit = slNumber % 10;
		strTemp[iNumDigits++] = '0' + (char)slSingleDigit;
		slNumber /= 10;
		}

	// do last digit
	strTemp[iNumDigits++] = '0' + (char)slNumber;
	
	// reverse the stringified number
	while (--iNumDigits >= 0)
		{
		*strOutput++ = strTemp[iNumDigits];
		}

	// null-terminate the string
	*strOutput = '\0';
	}


#define INT_TO_HEXCHAR(digit)	(char)((digit > 9) ? ('A' + digit - 10) : ('0' + digit))


// prints hex address of pointer
void FormatHex (char * strOutput, unsigned long ulPointer)
	{
	char strTemp[30];
	int iNumDigits = 0;
	signed long slSingleDigit;

	// put number in reverse order
	while (ulPointer > 15)
		{
		slSingleDigit = ulPointer % 16;
		strTemp[iNumDigits++] = INT_TO_HEXCHAR(slSingleDigit);
		ulPointer /= 16;
		}

	// do last digit
	strTemp[iNumDigits++] = INT_TO_HEXCHAR(ulPointer);
	
	// reverse the stringified number
	while (--iNumDigits >= 0)
		{
		*strOutput++ = strTemp[iNumDigits];
		}

	// null-terminate the string
	*strOutput = '\0';
	}
