//
// flash2ram.c (fstrcpy, fmemcpy)
//

// copy from flash to RAM

//
// These functions are intended to allow the C library functions
// to be used, as these only work with strings which are in
// RAM.
//

#include "flash2ram.h"

// strcpy but FROM flash memory
// not TO flash memory!
void fstrcpy (char * dest, char * src)
	{
	do
		{
		*dest = (char)flashReadByte(src);	
		src++;
		}
	while (*dest++ != '\0');
	}
	

// strcat from flash to ram	
void fstrcat (char * dest, char * src)
	{
	// go to end of destination string
	while (*dest != '\0')
		{
		dest++;
		}

	// append the new string	
	fstrcpy(dest, src);
	}

	
// memcpy but FROM flash memory
// not TO flash memory!
void fmemcpy (unsigned char * dest, unsigned char * src, int nbytes)
	{
	while (nbytes-- > 0)
		{
		// read the byte
		*dest = flashReadByte((char *)src);

		// increment pointers
		dest++;
		src++; 
		}
	}
	
