//
// flash2ram.h (fstrcpy, fmemcpy)
//

// copy from flash to RAM

//
// These functions are intended to allow the C library functions
// to be used, as these only work with strings which are in
// RAM.
//

#ifndef _FLASH2RAM_H
#define _FLASH2RAM_H

// fstrcpy() copies a string from FLASH to RAM
// see strcpy() for a more complete definition
extern void fstrcpy (char * dest, char * src);

// fstrcat() appends a string from FLASH to RAM
// see strcat() for a more complete definition
extern void fstrcat (char * dest, char * src);

// fmemcpy() copies bytes from FLASH to RAM
extern void fmemcpy (unsigned char * dest, unsigned char * src, int nbytes);

// flashReadByte() reads a single byte from FLASH and returns it.
#define flashReadByte(addr)	( (unsigned char) (* ((short *)addr) ) )
#endif