;
; Variable-width font utility
;

;
; Mark Baker, 4/1/99
;

;
; returns the length in pixels of a string printed using
; variable-width font.
;

	GET PERI.INC
	GET MACRO.INC

	IMPORT fontdatav46		
	EXPORT FontStrlen

	CODE16

	AREA LIB_VFONTUTIL, CODE, READONLY, INTERWORK

;---------------------------------------------
; function FontStrlen
; CODE16
; returns the length in pixels of s tring printed using
; variable-width font
;
; Letters it can print: 
;	!"#$%&'()*+,-./0123456789:;<=>?@
;	ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]_
;
; Parameters: 
;	r0  starting address of string
; Return value: none
; Registers used: r0-4
;---------------------------------------------
CHaddr	RN	0
length	RN	1
fptr	RN	2
tmp2	RN	3
fontchar	RN	4

FontStrlen
	PUSH	{ r3-r4 }
	PUSH	{ lr }

	MOV length, #0		; length is 0 initially

strloop
	F_LDRB	tmp2, CHaddr		; macro F_LDRB (byte load from FLASH)
	CMP	tmp2, #0
	BEQ	end			; stop if null character

calcaddr
	LDR	fptr, =fontdatav46	; detect font data address
	SUB	tmp2, #0x20
	LSL	tmp2, #2
	ADD	fptr, fptr, tmp2	; fptr= relevant font data address

	LDR fontchar, [fptr]	; load character data

	LSR tmp2, fontchar, #29		; shift to get width of character
	ADD	length, tmp2			; move X coordinate by that width

	MOV tmp2, #0xf
	TST fontchar, tmp2		; is there a 'next address' specified?
	BEQ nextchar

	; draw the bar at the end of some characters - re-use the I!
	MOV tmp2, #'I'		; set 'I' as the character to draw
	B calcaddr			; loop back to address calculation

nextchar
	ADD	CHaddr, #1		; next character
	B	strloop
end

	MOV r0, length		; return length

	POP	{ r3 }
	MOV	lr, r3
	POP	{ r3-r4 }
	BX	lr

    END
