//--------------------------------------------------------------------------
// File: main.h
// Author: George Bain
// Date: April 21, 1999
// Description: Prototypes
// Copyright (C) 1999 Sony Computer Entertainment Europe.,
//           All Rights Reserved.  
//--------------------------------------------------------------------------

#ifndef _MAIN_H
#define _MAIN_H

//--------------------------------------------------------------------------
// T Y P E D E F S
//--------------------------------------------------------------------------

typedef unsigned char u_char;
typedef unsigned long u_long;

typedef struct 
 {
   short x,y;
   short w,h;

 }RECT;

typedef struct 
 {
   RECT rect;
   u_char state;

 }OBJECT;

//--------------------------------------------------------------------------
// D E F I N E S
//-------------------------------------------------------------------------- 
 
#define PSPEED_X (1)
#define PSPEED_Y (1)
#define BSPEED_X (1)
#define BSPEED_Y (1)

#define DELAY (7000)
#define SCRN_SIZE (32)

#define NUM_BLOCKS (32)
#define BLOCK_ALIVE (1)
#define BLOCK_DEAD  (0)

#define PAD_W (6)
#define PAD_H (2)
#define	BALL_W (2)
#define BALL_H (2)

#define setRECT(r, _x, _y, _w, _h) \
	(r)->x = (_x),(r)->y = (_y),(r)->w = (_w),(r)->h = (_h)

//--------------------------------------------------------------------------
// G L O B A L S
//--------------------------------------------------------------------------

extern u_long screen[32];

//--------------------------------------------------------------------------
// P R O T O T Y P E S
//--------------------------------------------------------------------------

void InitBlocks( void );
void CheckBlocks( void );
void CheckBall( void );  
void CheckPaddle( void );

#endif

//----------------------------------EOF-------------------------------------
