;
;	CALLBACK.S
;
;	User callback functions
;	Functions need not preserve r2,r3
;
;	Ver1.0
;

	GET	PERI.INC

	EXPORT	FIQ_Callback_SPI
	EXPORT	IRQ_Callback_TC0
	EXPORT	IRQ_Callback_TC1
	EXPORT	IRQ_Callback_RTC
	EXPORT	IRQ_Callback_VOL
	EXPORT	IRQ_Callback_BAT
	EXPORT	IRQ_Callback_IF
	EXPORT	FIQ_Callback_TC2
	IMPORT	keybuff
	IMPORT	keys
	IMPORT  irbuff
	IMPORT	entertime

	CODE32
	AREA	CALLBACK,CODE,READONLY

FIQ_Callback_SPI
; Serial communication callback routine
;----------------------------------------------------------------------------
	MOV	pc,lr
;----------------------------------------------------------------------------

IRQ_Callback_TC0
; Timer 0 callback routine
; Used by button handler
;----------------------------------------------------------------------------
	STMDB sp!,{r0,r1}
	MOV 	r0,#0x80
	LDR		r1,=INTSourceClear
	STR 	r0,[r1]
	LDR		r1,=keybuff
	LDRH	r0,[r1]
	MOV		r2,#0
	STRH	r2,[r1]
	LDR		r1,=keys
	STRH	r0,[r1]

;	Now update how long enter is pressed for
	LDR		r1,=entertime
	LDR		r2,[r1]
	ANDS	r0,r0,#1
	MOVEQ	r2,#0
	ADDNE	r2,r2,#1
	STR		r2,[r1]	

	LDR		r1,=INTEnableSet
	MOV		r0,#0x1f
	STR		r0,[r1]
	LDMIA sp!,{r0,r1}
	MOV pc,lr
;----------------------------------------------------------------------------

IRQ_Callback_TC1
; Timer 1 callback routine
;----------------------------------------------------------------------------
	MOV	pc,lr
;----------------------------------------------------------------------------

IRQ_Callback_RTC
; Real-Time Clock callback routine
;----------------------------------------------------------------------------
	MOV	pc,lr
;----------------------------------------------------------------------------

IRQ_Callback_VOL
; Low power callback routine
;----------------------------------------------------------------------------
	MOV	pc,lr
;----------------------------------------------------------------------------

IRQ_Callback_BAT
; PS interface activation/deactivation callback
;----------------------------------------------------------------------------
	MOV	pc,lr
;----------------------------------------------------------------------------

IRQ_Callback_IF
; IR communication callback
;----------------------------------------------------------------------------
	MOV	pc,lr
;----------------------------------------------------------------------------

FIQ_Callback_TC2
; Timer 2 callback
;----------------------------------------------------------------------------
	MOV pc,lr
;----------------------------------------------------------------------------
	END