#!/usr/bin/perl
# 
# ScreenConvert
#

#
# converts from PocketStation screen memory format to RAW pixel format
# 8-bit greyscale, 32 x 32 pixels
#
# (wouldn't be necessary if PhotoShop & Paint Shop Pro loaded RAW files
# with 1-bit greyscale!)
#

# reads from STDIN, writes to STDOUT - redirect to choose files

open SCREEN_IN, "<&STDIN" or die "Can't open input";
#open RAW_OUT, ">&STDOUT" or die "Can't open output";

# define pixel 'colours'
$white_pixel = pack "C", 0xff;
$black_pixel = pack "C", 0x00;

# read each line of the screen
while (read SCREEN_IN, $screen_line, 4)
	{
	# expand it
	@bytes = unpack "CCCC", $screen_line;
	
	# take each byte
	foreach $byte (@bytes) 
		{
		#print "$byte ";
		
		# print each bit
		for ($index = 0; $index < 8; $index++)
			{
			# extract a bit
			$bit = ($byte >> $index) & 0x01;
			
			# output it
			if ($bit == 0)
				{
				print $white_pixel;
				}
			else 
				{
				print $black_pixel;
				}
			}
		}
	}
	